#include "project.h"

#ifndef PI
#define PI 3.141592654
#endif

#define FILLN 1

long int pts;

char *format="%.1f";
int text=0;

/* This should be larger that the longest line / but not too critical */

#define NPTS 300000




typedef struct  {
	float 		*data;
	unsigned char  	*flags;
	int width,height;
	int jlim,ilim;
} alt_descriptor ;


#define ALT_RAD(alt,i,j) ((*(alt.data+(alt.width*(j))+(i))))
#define ALT_FLAGS(alt,i,j) (*(alt.flags+(alt.width*(j))+(i)))

#define ILIM(alt,i) ((i>1) ? ( (i<alt.ilim) ? i : (alt.ilim-1) ): 2)
#define JLIM(alt,j) ((j>1) ? ( (j<alt.jlim) ? j : (alt.jlim-1) ): 2)

#define ALT_Y(alt,i,j) ((float) (JLIM(alt,j)-1))
#define ALT_X(alt,i,j) ((float) (ILIM(alt,i)-1))
#define ALT_SFLG(alt,i,j) (*(alt.flags+(alt.width*(j))+(i)))|=1;


#define mgnview_max(a,b) ((a>b) ? a : b)
#define mgnview_min(a,b) ((a<b) ? a : b)

int do_abort=0;



void iprocs(moo,series,ui1, uj1, ui2, uj2, uil, ujl, type, alt, maxxl1, maxyl1,
  minx, miny, clevel)
Handle moo;
Jwgline *series;
int maxxl1;
int maxyl1;
int minx;
int miny;
float clevel;
int ui1, uj1, ui2, uj2, uil, ujl, type;
alt_descriptor alt;
{
  Jwgpos *ptr;


  int i1, j1, i2, j2, il, jl;
  float g, f1, f2, f3, f4;
  float r1, r2;
  int it;

  int xp, yp, ox, oy;
  int in, jn;
  int stayin;
  float y, x;
  char lbl[80];



ptr=series->data+series->npts;

  i1 = ui1;
  i2 = ui2;
  j1 = uj1;
  j2 = uj2;
  il = uil;
  jl = ujl;



  r2 = ALT_RAD(alt, i2, j2);
  r1 = ALT_RAD(alt, i1, j1);


  f1 = (clevel - r2);
  f2 = (r1 - r2);
  if (f2 > 0)
    g = f1 / f2;
  else
    g = 0;


  f3 = ALT_X(alt, i1, j1);
  f4 = ALT_X(alt, i2, j2);
  f2 = f4;

  if ((f3 - f4) > 10)
    f4 = f4 + 360;
  if ((f3 - f4) < -10)
    f4 = f4 - 360;

  f1 = (f3 - f4);

  f1 = f1 * g;
  f1 = f1 + f2;
  x = f1;

  f2 = ALT_Y(alt, i2, j2);
  f1 = (ALT_Y(alt, i1, j1) - f2);
  f1 = f1 * g;
  f1 = f1 + f2;
  y = f1;







ptr->y=y;
ptr->x=x;

jwg_xform(moo,ptr);

/*
sprintf(lbl,format,clevel);
if (text) map_write_text_at(moo,ptr,lbl);
*/

ptr++;
series->npts++;






  stayin = 1;

  while (stayin == 1)
  {

    in = i1 + i2 - il;
    jn = j1 + j2 - jl;
    if ((in < minx) || (in > maxxl1) || (jn < miny) || (jn > maxyl1))
    {
 
	printf("i1=%d,j1=%d,r1=%f\n",i1,j1,ALT_RAD(alt,i1,j1));
	printf("i2=%d,j2=%d,r2=%f\n",i2,j2,ALT_RAD(alt,i2,j2));
	printf("in=%d,jn=%d\n",in,jn);
	printf("il=%d,jl=%d\n",il,jl);

	printf("Contour exception: %f\n", clevel);




 
      return;
    }

    if (ALT_RAD(alt, in, jn) >= clevel)
    {
      il = i1;
      jl = j1;
      i1 = in;
      j1 = jn;
    }
    else
    {
      il = i2;
      jl = j2;
      i2 = in;
      j2 = jn;
    }

    r1 = ALT_RAD(alt, i1, j1);
    r2 = ALT_RAD(alt, i2, j2);


    f1 = (clevel - r2);
    f2 = (r1 - r2);
    if (f2 > 0)
      g = f1 / f2;
    else
      g = 0;

    if ((j1 == j2) && (j1 != miny) && (j1 != maxyl1) /*&& (mgnview_max(i1, i2) != maxxl1)*/)
    {
      it = mgnview_min(i1, i2);
      ALT_SFLG(alt, it, j1);
    }



    f3 = ALT_X(alt, i1, j1);
    f4 = ALT_X(alt, i2, j2);
    f2 = f4;

    if ((f3 - f4) > 10)
      f4 = f4 + 360;
    if ((f3 - f4) < -10)
      f4 = f4 - 360;

    f1 = (f3 - f4);
    f1 = f1 * g;
    f1 = f1 + f4;
    x = f1;

    f2 = ALT_Y(alt, i2, j2);
    f1 = (ALT_Y(alt, i1, j1) - f2);
    f1 = f1 * g;
    f1 = f1 + f2;
    y = f1;


ptr->y=y;
ptr->x=x;

jwg_xform(moo,ptr);

ptr++;
series->npts++;



    stayin = 0;

    if (type != 5)
      stayin = 1;
    if (i1 != ui1)
      stayin = 1;
    if (j1 != uj1)
      stayin = 1;
    if (i2 != ui2)
      stayin = 1;
    if (j2 != uj2)
      stayin = 1;

  }

}





void contor(moo,alt, clevel,fb,lp)
Handle moo;
alt_descriptor alt;
float clevel;
int fb,lp;
{
  int maxxl1, maxxl2, maxyl1;
  int i, j;

  float *rad_ptr;
  unsigned char  *flags_ptr;

  int maxx, maxy;
  int minyp1;

  int minx = 0;
  int miny = 0;

  Jwgline rline;
  Jwgline *line=&rline;
  Jwgpos *ptr,*sptr;


  float huge=1.0e20*(float) fb;

  maxx = alt.width;
  maxy = alt.height;

  minyp1 = miny + 1;
  maxxl1 = maxx - 1;
  maxxl2 = maxx - 2;
  maxyl1 = maxy - 1;

  flags_ptr=alt.flags;


  rad_ptr=alt.data;

  for (j=miny;(j<maxy);++j) {
  for (i=minx;(i<maxx);++i) {
	*flags_ptr=0;
	flags_ptr++;
  }
  }

  for (j=miny;(j<maxy);++j) {
	ALT_RAD(alt,minx,j)=huge;
	ALT_RAD(alt,minx+1,j)=huge;
	ALT_RAD(alt,maxxl1-1,j)=huge;
	ALT_RAD(alt,maxxl1,j)=huge;
	}
  for (i=minx;(i<maxx);++i) {
	ALT_RAD(alt,i,miny)=huge;
	ALT_RAD(alt,i,miny+1)=huge;
	ALT_RAD(alt,i,maxyl1-1)=huge;
	ALT_RAD(alt,i,maxyl1)=huge;
  }
/*
printf("Contouring the following data\n");

for (i=minx;(i<maxx);++i) {
for (j=miny;(j<maxy);++j) {
printf("%02.2f\t",ALT_RAD(alt,i,j));
}
printf("\n");
}
*/



line->npts=0;
ptr=line->data=(Jwgpos *) malloc(sizeof(Jwgpos)*NPTS);


  rad_ptr = alt.data + alt.width;
  flags_ptr=alt.flags+ alt.width;

  for (j = minyp1; (j < maxyl1) && (do_abort == 0); ++j)
  {
    for (i = minx; (i < maxxl2) && (do_abort == 0); ++i)
    {

      if ((*rad_ptr >= clevel) && (*(rad_ptr + 1) < clevel))
	if ((*flags_ptr & 1) == 0)
	{
	  *flags_ptr|= 1;
	if (fb!=0) {

		ptr->y=ALT_Y(alt,minx,miny);
		ptr->x=ALT_X(alt,minx,miny);
		jwg_xform(moo,ptr);
		sptr=ptr;

		ptr++;
		line->npts++;
	}

	  iprocs(moo,line,i, j, i + 1, j, i + 1, j - 1, 5, alt, 
		maxxl1, maxyl1, minx, miny, clevel);

	ptr=line->data+line->npts;

	
	if (fb!=0) {

		ptr->y=(sptr+1)->y;
		ptr->x=(sptr+1)->x;
		ptr++;
		line->npts++;
		ptr->y=sptr->y;
		ptr->x=sptr->x;
		ptr++;
		line->npts++;
	} else {

		if (line->npts) {
			if (lp) jwg_write_line(moo,line);
				else jwg_write_polygon(moo,line);
			printf(".");
			fflush(stdout);
		}
		line->npts=0;
		ptr=line->data;

	}


	}
      rad_ptr++;
      flags_ptr++;	
    }
    rad_ptr+=2;
    flags_ptr+=2;
  }


		if (line->npts) {
			if (lp) jwg_write_line(moo,line);
				else jwg_write_polygon(moo,line);

			printf(".");
			fflush(stdout);
		}

free(line->data);


}





void do_contour(Handle h,float level,int side,int lp)
{
alt_descriptor alt;

alt.width=h->data->w;
alt.height=h->data->h;
alt.ilim=alt.width-2;
alt.jlim=alt.height-2;

pts=alt.width*alt.height;

alt.data=h->data->data;
alt.flags=(unsigned char *) malloc(pts);
bzero(alt.flags,pts);
printf("(%f)",level);
fflush(stdout);
contor(h,alt,level,side,lp);
printf("\n");

free(alt.flags);

}



