#ifndef OBJECT_IN
#define OBJECT_IN

#define CREATOR(x) static void (*x ## _default_creator)(x)
#define DESTRUCTOR(x) static void (*x ## _default_destructor)(x)

#ifdef OBJ_NOTINALL
#ifdef OBJ_INTHIS
#define BEGIN_OBJECT(x) \
	struct x ## _struct { \
	struct x ## _struct *prev;\
	struct x ## _struct *next;\
	unsigned int len;\
	void (*destructor)();
#define END_OBJECT(x)	}; \
	typedef struct x ## _struct * x;\
	typedef struct x ## _list_struct { \
	caddr_t prev;\
	caddr_t next;\
	unsigned int len;\
	void (*destructor)(struct x ## _list_struct *);\
	x head;\
	x tail;\
	} *x ## _list;\
	extern void (*x ## _default_creator)(x); \
	extern void (*x ## _default_destructor)(x); \
	x x ## _default_alloca(void) {\
	x res;\
	res=(x) malloc(sizeof(struct x ## _struct));\
	if (!res) return((x) 0);\
	bzero((void *) res,sizeof(struct x ## _struct));\
	Obj_Init(res);\
	res->len=sizeof(struct x ## _struct);\
	res->destructor=x ## _default_destructor;\
	(*x ## _default_creator)(res);\
	return(res);\
	} \
	x ## _list x ## _list_alloca(void) {\
	x ## _list res;\
	res=(x ## _list) malloc(sizeof(struct x ## _list_struct));\
	if (!res) return((x ## _list) 0);\
	Obj_Init(res);\
	res->destructor=Obj_DeleteList;\
	Obj_CreateList(res);\
	return(res);\
	}

#else
#define BEGIN_OBJECT(x) \
	struct x ## _struct { \
	struct x ## _struct *prev;\
	struct x ## _struct *next;\
	unsigned int len;\
	void (*destructor)();
#define END_OBJECT(x)	}; \
	typedef struct x ## _struct * x;\
	typedef struct x ## _list_struct { \
	caddr_t prev;\
	caddr_t next;\
	unsigned int len;\
	void (*destructor)(struct x ## _list_struct *);\
	x head;\
	x tail;\
	} *x ## _list;\
	extern void (*x ## _default_creator)(x); \
	extern void (*x ## _default_destructor)(x); \
	extern x x ## _default_alloca(void); \
	extern x ## _list x ## _list_alloca(void);
#endif
#else

#define BEGIN_OBJECT(x) \
	struct x ## _struct { \
	struct x ## _struct *prev;\
	struct x ## _struct *next;\
	unsigned int len;\
	void (*destructor)();
#define END_OBJECT(x)	}; \
	typedef struct x ## _struct * x;\
	typedef struct x ## _list_struct { \
	caddr_t prev;\
	caddr_t next;\
	unsigned int len;\
	void (*destructor)(struct x ## _list_struct *);\
	x head;\
	x tail;\
	} *x ## _list;\
	extern void (*x ## _default_creator)(x); \
	extern void (*x ## _default_destructor)(x); \
	static x x ## _default_alloca(void) {\
	x res;\
	res=(x) malloc(sizeof(struct x ## _struct));\
	if (!res) return((x) 0);\
	bzero((void *) res,sizeof(struct x ## _struct));\
	Obj_Init(res);\
	res->len=sizeof(struct x ## _struct);\
	res->destructor=x ## _default_destructor;\
	(*x ## _default_creator)(res);\
	return(res);\
	} \
	static x ## _list x ## _list_alloca(void) {\
	x ## _list res;\
	res=(x ## _list) malloc(sizeof(struct x ## _list_struct));\
	if (!res) return((x ## _list) 0);\
	Obj_Init(res);\
	res->destructor=Obj_DeleteList;\
	Obj_CreateList(res);\
	return(res);\
	}


#endif


#define CREATE_OBJ(x) x ## _default_alloca()
#define CREATE_LIST(x) x ## _list_alloca()
#define OBJ_SIZE(x) sizeof(struct x ## _struct)

typedef struct {
caddr_t prev;
caddr_t next;
unsigned int len;
void (*destructor)();
} Object;

typedef struct {
caddr_t prev;
caddr_t next;
unsigned int len;
void (*destructor)();
Object *head,*tail;
} List;

#define ObjInsertHead	1
#define ObjInsertTail	2

extern void Obj_DefaultDestructor();
extern void Obj_DefaultCreator();
extern void Obj_CreateList();
extern void Obj_Init();
extern void Obj_Delete();
extern void Obj_DeleteList();
extern void Obj_Remove();
extern void Obj_Insert();
extern void Obj_InsertAfter();
#endif	
